import dataPointsDataLogsPageElements from "../../../../support/elements/dashboard/manage/dataPoints/dataPoints";

const verifyStaticElementsOfPage = () => {
    cy.verifyElement({
        labelElement: dataPointsDataLogsPageElements.PAGE_TITLE,
        labelText: "Data Points",
        tooltipElement: dataPointsDataLogsPageElements.PAGE_TITLE_TOOLTIP,
        tooltipText: "Sessions, events (custom events + internal events generated by plugins) and data points (sessions + events) for the selected period"
    });

    cy.verifyElement({
        labelElement: dataPointsDataLogsPageElements.TOP_APPLICATIONS_BY_DATA_POINTS_LABEL,
        labelText: "Top applications by data points in the last 2 hours"
    });

    cy.verifyElement({
        element: dataPointsDataLogsPageElements.FILTER_DATE_PICKER,
    });

    cy.verifyElement({
        element: dataPointsDataLogsPageElements.APPS_TABLE,
    });
};

const verifyEmptyPageElements = () => {

    verifyStaticElementsOfPage();

    cy.verifyElement({
        element: dataPointsDataLogsPageElements.EMPTY_PAGE_ICON,
    });

    cy.verifyElement({
        labelElement: dataPointsDataLogsPageElements.EMPTY_PAGE_TITLE,
        labelText: "...hmm, seems empty here",
    });

    cy.verifyElement({
        labelElement: dataPointsDataLogsPageElements.EMPTY_PAGE_SUBTITLE,
        labelText: "No data found",
    });
};

module.exports = {
    verifyEmptyPageElements,
};