var getTimeZones = {"AD": {"n": "Andorra", "z": [{"(GMT+01:00) Andorra": "Europe/Andorra"}]}, "AE": {"n": "United Arab Emirates", "z": [{"(GMT+04:00) Dubai": "Asia/Dubai"}]}, "AF": {"n": "Afghanistan", "z": [{"(GMT+04:30) Kabul": "Asia/Kabul"}]}, "AG": {"n": "Antigua and Barbuda", "z": [{"(GMT-04:00) Antigua": "America/Antigua"}]}, "AI": {"n": "Anguilla", "z": [{"(GMT-04:00) Anguilla": "America/Anguilla"}]}, "AL": {"n": "Albania", "z": [{"(GMT+01:00) Tirane": "Europe/Tirane"}]}, "AM": {"n": "Armenia", "z": [{"(GMT+04:00) Yerevan": "Asia/Yerevan"}]}, "AO": {"n": "Angola", "z": [{"(GMT+01:00) Luanda": "Africa/Luanda"}]}, "AQ": {"n": "Antarctica", "z": [{"(GMT+08:00) Casey": "Antarctica/Casey"}, {"(GMT+07:00) Davis": "Antarctica/Davis"}, {"(GMT+10:00) DumontDUrville": "Antarctica/DumontDUrville"}, {"(GMT+05:00) Mawson": "Antarctica/Mawson"}, {"(GMT+13:00) McMurdo": "Antarctica/McMurdo"}, {"(GMT-03:00) Palmer": "Antarctica/Palmer"}, {"(GMT-03:00) Rothera": "Antarctica/Rothera"}, {"(GMT+03:00) Syowa": "Antarctica/Syowa"}, {"(GMT+00:00) Troll": "Antarctica/Troll"}, {"(GMT+06:00) Vostok": "Antarctica/Vostok"}]}, "AR": {"n": "Argentina", "z": [{"(GMT-03:00) Argentina": "America/Argentina/Buenos_Aires"}, {"(GMT-03:00) Argentina": "America/Argentina/Catamarca"}, {"(GMT-03:00) Argentina": "America/Argentina/Cordoba"}, {"(GMT-03:00) Argentina": "America/Argentina/Jujuy"}, {"(GMT-03:00) Argentina": "America/Argentina/La_Rioja"}, {"(GMT-03:00) Argentina": "America/Argentina/Mendoza"}, {"(GMT-03:00) Argentina": "America/Argentina/Rio_Gallegos"}, {"(GMT-03:00) Argentina": "America/Argentina/Salta"}, {"(GMT-03:00) Argentina": "America/Argentina/San_Juan"}, {"(GMT-03:00) Argentina": "America/Argentina/San_Luis"}, {"(GMT-03:00) Argentina": "America/Argentina/Tucuman"}, {"(GMT-03:00) Argentina": "America/Argentina/Ushuaia"}]}, "AS": {"n": "American Samoa", "z": [{"(GMT-11:00) Pago_Pago": "Pacific/Pago_Pago"}]}, "AT": {"n": "Austria", "z": [{"(GMT+01:00) Vienna": "Europe/Vienna"}]}, "AU": {"n": "Australia", "z": [{"(GMT+11:00) Macquarie": "Antarctica/Macquarie"}, {"(GMT+10:30) Adelaide": "Australia/Adelaide"}, {"(GMT+10:00) Brisbane": "Australia/Brisbane"}, {"(GMT+10:30) Broken_Hill": "Australia/Broken_Hill"}, {"(GMT+11:00) Currie": "Australia/Currie"}, {"(GMT+09:30) Darwin": "Australia/Darwin"}, {"(GMT+08:45) Eucla": "Australia/Eucla"}, {"(GMT+11:00) Hobart": "Australia/Hobart"}, {"(GMT+10:00) Lindeman": "Australia/Lindeman"}, {"(GMT+11:00) Lord_Howe": "Australia/Lord_Howe"}, {"(GMT+11:00) Melbourne": "Australia/Melbourne"}, {"(GMT+08:00) Perth": "Australia/Perth"}, {"(GMT+11:00) Sydney": "Australia/Sydney"}]}, "AW": {"n": "Aruba", "z": [{"(GMT-04:00) Aruba": "America/Aruba"}]}, "AX": {"n": "Aland Islands", "z": [{"(GMT+02:00) Mariehamn": "Europe/Mariehamn"}]}, "AZ": {"n": "Azerbaijan", "z": [{"(GMT+04:00) Baku": "Asia/Baku"}]}, "BA": {"n": "Bosnia and Herzegovina", "z": [{"(GMT+01:00) Sarajevo": "Europe/Sarajevo"}]}, "BB": {"n": "Barbados", "z": [{"(GMT-04:00) Barbados": "America/Barbados"}]}, "BD": {"n": "Bangladesh", "z": [{"(GMT+06:00) Dhaka": "Asia/Dhaka"}]}, "BE": {"n": "Belgium", "z": [{"(GMT+01:00) Brussels": "Europe/Brussels"}]}, "BF": {"n": "Burkina Faso", "z": [{"(GMT+00:00) Ouagadougou": "Africa/Ouagadougou"}]}, "BG": {"n": "Bulgaria", "z": [{"(GMT+02:00) Sofia": "Europe/Sofia"}]}, "BH": {"n": "Bahrain", "z": [{"(GMT+03:00) Bahrain": "Asia/Bahrain"}]}, "BI": {"n": "Burundi", "z": [{"(GMT+02:00) Bujumbura": "Africa/Bujumbura"}]}, "BJ": {"n": "Benin", "z": [{"(GMT+01:00) Porto-Novo": "Africa/Porto-Novo"}]}, "BL": {"n": "Saint Barthélemy", "z": [{"(GMT-04:00) St_Barthelemy": "America/St_Barthelemy"}]}, "BM": {"n": "Bermuda", "z": [{"(GMT-04:00) Bermuda": "Atlantic/Bermuda"}]}, "BN": {"n": "Brunei", "z": [{"(GMT+08:00) Brunei": "Asia/Brunei"}]}, "BO": {"n": "Bolivia", "z": [{"(GMT-04:00) La_Paz": "America/La_Paz"}]}, "BQ": {"n": "Bonaire, Saint Eustatius and Saba ", "z": [{"(GMT-04:00) Kralendijk": "America/Kralendijk"}]}, "BR": {"n": "Brazil", "z": [{"(GMT-03:00) Araguaina": "America/Araguaina"}, {"(GMT-03:00) Bahia": "America/Bahia"}, {"(GMT-03:00) Belem": "America/Belem"}, {"(GMT-04:00) Boa_Vista": "America/Boa_Vista"}, {"(GMT-04:00) Campo_Grande": "America/Campo_Grande"}, {"(GMT-04:00) Cuiaba": "America/Cuiaba"}, {"(GMT-05:00) Eirunepe": "America/Eirunepe"}, {"(GMT-03:00) Fortaleza": "America/Fortaleza"}, {"(GMT-03:00) Maceio": "America/Maceio"}, {"(GMT-04:00) Manaus": "America/Manaus"}, {"(GMT-02:00) Noronha": "America/Noronha"}, {"(GMT-04:00) Porto_Velho": "America/Porto_Velho"}, {"(GMT-03:00) Recife": "America/Recife"}, {"(GMT-05:00) Rio_Branco": "America/Rio_Branco"}, {"(GMT-03:00) Santarem": "America/Santarem"}, {"(GMT-03:00) Sao_Paulo": "America/Sao_Paulo"}]}, "BS": {"n": "Bahamas", "z": [{"(GMT-05:00) Nassau": "America/Nassau"}]}, "BT": {"n": "Bhutan", "z": [{"(GMT+06:00) Thimphu": "Asia/Thimphu"}]}, "BW": {"n": "Botswana", "z": [{"(GMT+02:00) Gaborone": "Africa/Gaborone"}]}, "BY": {"n": "Belarus", "z": [{"(GMT+03:00) Minsk": "Europe/Minsk"}]}, "BZ": {"n": "Belize", "z": [{"(GMT-06:00) Belize": "America/Belize"}]}, "CA": {"n": "Canada", "z": [{"(GMT-05:00) Atikokan": "America/Atikokan"}, {"(GMT-04:00) Blanc-Sablon": "America/Blanc-Sablon"}, {"(GMT-07:00) Cambridge_Bay": "America/Cambridge_Bay"}, {"(GMT-07:00) Creston": "America/Creston"}, {"(GMT-07:00) Dawson": "America/Dawson"}, {"(GMT-07:00) Dawson_Creek": "America/Dawson_Creek"}, {"(GMT-07:00) Edmonton": "America/Edmonton"}, {"(GMT-07:00) Fort_Nelson": "America/Fort_Nelson"}, {"(GMT-04:00) Glace_Bay": "America/Glace_Bay"}, {"(GMT-04:00) Goose_Bay": "America/Goose_Bay"}, {"(GMT-04:00) Halifax": "America/Halifax"}, {"(GMT-07:00) Inuvik": "America/Inuvik"}, {"(GMT-05:00) Iqaluit": "America/Iqaluit"}, {"(GMT-04:00) Moncton": "America/Moncton"}, {"(GMT-05:00) Nipigon": "America/Nipigon"}, {"(GMT-05:00) Pangnirtung": "America/Pangnirtung"}, {"(GMT-06:00) Rainy_River": "America/Rainy_River"}, {"(GMT-06:00) Rankin_Inlet": "America/Rankin_Inlet"}, {"(GMT-06:00) Regina": "America/Regina"}, {"(GMT-06:00) Resolute": "America/Resolute"}, {"(GMT-03:30) St_Johns": "America/St_Johns"}, {"(GMT-06:00) Swift_Current": "America/Swift_Current"}, {"(GMT-05:00) Thunder_Bay": "America/Thunder_Bay"}, {"(GMT-05:00) Toronto": "America/Toronto"}, {"(GMT-08:00) Vancouver": "America/Vancouver"}, {"(GMT-07:00) Whitehorse": "America/Whitehorse"}, {"(GMT-06:00) Winnipeg": "America/Winnipeg"}, {"(GMT-07:00) Yellowknife": "America/Yellowknife"}]}, "CC": {"n": "Cocos Islands", "z": [{"(GMT+06:30) Cocos": "Indian/Cocos"}]}, "CD": {"n": "Democratic Republic of the Congo", "z": [{"(GMT+01:00) Kinshasa": "Africa/Kinshasa"}, {"(GMT+02:00) Lubumbashi": "Africa/Lubumbashi"}]}, "CF": {"n": "Central African Republic", "z": [{"(GMT+01:00) Bangui": "Africa/Bangui"}]}, "CG": {"n": "Republic of the Congo", "z": [{"(GMT+01:00) Brazzaville": "Africa/Brazzaville"}]}, "CH": {"n": "Switzerland", "z": [{"(GMT+01:00) Zurich": "Europe/Zurich"}]}, "CI": {"n": "Ivory Coast", "z": [{"(GMT+00:00) Abidjan": "Africa/Abidjan"}]}, "CK": {"n": "Cook Islands", "z": [{"(GMT-10:00) Rarotonga": "Pacific/Rarotonga"}]}, "CL": {"n": "Chile", "z": [{"(GMT-03:00) Punta_Arenas": "America/Punta_Arenas"}, {"(GMT-03:00) Santiago": "America/Santiago"}, {"(GMT-05:00) Easter": "Pacific/Easter"}]}, "CM": {"n": "Cameroon", "z": [{"(GMT+01:00) Douala": "Africa/Douala"}]}, "CN": {"n": "China", "z": [{"(GMT+08:00) Shanghai": "Asia/Shanghai"}, {"(GMT+06:00) Urumqi": "Asia/Urumqi"}]}, "CO": {"n": "Colombia", "z": [{"(GMT-05:00) Bogota": "America/Bogota"}]}, "CR": {"n": "Costa Rica", "z": [{"(GMT-06:00) Costa_Rica": "America/Costa_Rica"}]}, "CU": {"n": "Cuba", "z": [{"(GMT-05:00) Havana": "America/Havana"}]}, "CV": {"n": "Cape Verde", "z": [{"(GMT-01:00) Cape_Verde": "Atlantic/Cape_Verde"}]}, "CW": {"n": "Curaçao", "z": [{"(GMT-04:00) Curacao": "America/Curacao"}]}, "CX": {"n": "Christmas Island", "z": [{"(GMT+07:00) Christmas": "Indian/Christmas"}]}, "CY": {"n": "Cyprus", "z": [{"(GMT+02:00) Famagusta": "Asia/Famagusta"}, {"(GMT+02:00) Nicosia": "Asia/Nicosia"}]}, "CZ": {"n": "Czech Republic", "z": [{"(GMT+01:00) Prague": "Europe/Prague"}]}, "DE": {"n": "Germany", "z": [{"(GMT+01:00) Berlin": "Europe/Berlin"}, {"(GMT+01:00) Busingen": "Europe/Busingen"}]}, "DJ": {"n": "Djibouti", "z": [{"(GMT+03:00) Djibouti": "Africa/Djibouti"}]}, "DK": {"n": "Denmark", "z": [{"(GMT+01:00) Copenhagen": "Europe/Copenhagen"}]}, "DM": {"n": "Dominica", "z": [{"(GMT-04:00) Dominica": "America/Dominica"}]}, "DO": {"n": "Dominican Republic", "z": [{"(GMT-04:00) Santo_Domingo": "America/Santo_Domingo"}]}, "DZ": {"n": "Algeria", "z": [{"(GMT+01:00) Algiers": "Africa/Algiers"}]}, "EC": {"n": "Ecuador", "z": [{"(GMT-05:00) Guayaquil": "America/Guayaquil"}, {"(GMT-06:00) Galapagos": "Pacific/Galapagos"}]}, "EE": {"n": "Estonia", "z": [{"(GMT+02:00) Tallinn": "Europe/Tallinn"}]}, "EG": {"n": "Egypt", "z": [{"(GMT+02:00) Cairo": "Africa/Cairo"}]}, "EH": {"n": "Western Sahara", "z": [{"(GMT+01:00) El_Aaiun": "Africa/El_Aaiun"}]}, "ER": {"n": "Eritrea", "z": [{"(GMT+03:00) Asmara": "Africa/Asmara"}]}, "ES": {"n": "Spain", "z": [{"(GMT+01:00) Ceuta": "Africa/Ceuta"}, {"(GMT+00:00) Canary": "Atlantic/Canary"}, {"(GMT+01:00) Madrid": "Europe/Madrid"}]}, "ET": {"n": "Ethiopia", "z": [{"(GMT+03:00) Addis_Ababa": "Africa/Addis_Ababa"}]}, "FI": {"n": "Finland", "z": [{"(GMT+02:00) Helsinki": "Europe/Helsinki"}]}, "FJ": {"n": "Fiji", "z": [{"(GMT+13:00) Fiji": "Pacific/Fiji"}]}, "FK": {"n": "Falkland Islands", "z": [{"(GMT-03:00) Stanley": "Atlantic/Stanley"}]}, "FM": {"n": "Micronesia", "z": [{"(GMT+10:00) Chuuk": "Pacific/Chuuk"}, {"(GMT+11:00) Kosrae": "Pacific/Kosrae"}, {"(GMT+11:00) Pohnpei": "Pacific/Pohnpei"}]}, "FO": {"n": "Faroe Islands", "z": [{"(GMT+00:00) Faroe": "Atlantic/Faroe"}]}, "FR": {"n": "France", "z": [{"(GMT+01:00) Paris": "Europe/Paris"}]}, "GA": {"n": "Gabon", "z": [{"(GMT+01:00) Libreville": "Africa/Libreville"}]}, "GB": {"n": "United Kingdom", "z": [{"(GMT+00:00) London": "Europe/London"}]}, "GD": {"n": "Grenada", "z": [{"(GMT-04:00) Grenada": "America/Grenada"}]}, "GE": {"n": "Georgia", "z": [{"(GMT+04:00) Tbilisi": "Asia/Tbilisi"}]}, "GF": {"n": "French Guiana", "z": [{"(GMT-03:00) Cayenne": "America/Cayenne"}]}, "GG": {"n": "Guernsey", "z": [{"(GMT+00:00) Guernsey": "Europe/Guernsey"}]}, "GH": {"n": "Ghana", "z": [{"(GMT+00:00) Accra": "Africa/Accra"}]}, "GI": {"n": "Gibraltar", "z": [{"(GMT+01:00) Gibraltar": "Europe/Gibraltar"}]}, "GL": {"n": "Greenland", "z": [{"(GMT+00:00) Danmarkshavn": "America/Danmarkshavn"}, {"(GMT-03:00) Nuuk": "America/Nuuk"}, {"(GMT-01:00) Scoresbysund": "America/Scoresbysund"}, {"(GMT-04:00) Thule": "America/Thule"}]}, "GM": {"n": "Gambia", "z": [{"(GMT+00:00) Banjul": "Africa/Banjul"}]}, "GN": {"n": "Guinea", "z": [{"(GMT+00:00) Conakry": "Africa/Conakry"}]}, "GP": {"n": "Guadeloupe", "z": [{"(GMT-04:00) Guadeloupe": "America/Guadeloupe"}]}, "GQ": {"n": "Equatorial Guinea", "z": [{"(GMT+01:00) Malabo": "Africa/Malabo"}]}, "GR": {"n": "Greece", "z": [{"(GMT+02:00) Athens": "Europe/Athens"}]}, "GS": {"n": "South Georgia and the South Sandwich Islands", "z": [{"(GMT-02:00) South_Georgia": "Atlantic/South_Georgia"}]}, "GT": {"n": "Guatemala", "z": [{"(GMT-06:00) Guatemala": "America/Guatemala"}]}, "GU": {"n": "Guam", "z": [{"(GMT+10:00) Guam": "Pacific/Guam"}]}, "GW": {"n": "Guinea-Bissau", "z": [{"(GMT+00:00) Bissau": "Africa/Bissau"}]}, "GY": {"n": "Guyana", "z": [{"(GMT-04:00) Guyana": "America/Guyana"}]}, "HK": {"n": "Hong Kong", "z": [{"(GMT+08:00) Hong_Kong": "Asia/Hong_Kong"}]}, "HN": {"n": "Honduras", "z": [{"(GMT-06:00) Tegucigalpa": "America/Tegucigalpa"}]}, "HR": {"n": "Croatia", "z": [{"(GMT+01:00) Zagreb": "Europe/Zagreb"}]}, "HT": {"n": "Haiti", "z": [{"(GMT-05:00) Port-au-Prince": "America/Port-au-Prince"}]}, "HU": {"n": "Hungary", "z": [{"(GMT+01:00) Budapest": "Europe/Budapest"}]}, "ID": {"n": "Indonesia", "z": [{"(GMT+07:00) Jakarta": "Asia/Jakarta"}, {"(GMT+09:00) Jayapura": "Asia/Jayapura"}, {"(GMT+08:00) Makassar": "Asia/Makassar"}, {"(GMT+07:00) Pontianak": "Asia/Pontianak"}]}, "IE": {"n": "Ireland", "z": [{"(GMT+00:00) Dublin": "Europe/Dublin"}]}, "IL": {"n": "Israel", "z": [{"(GMT+02:00) Jerusalem": "Asia/Jerusalem"}]}, "IM": {"n": "Isle of Man", "z": [{"(GMT+00:00) Isle_of_Man": "Europe/Isle_of_Man"}]}, "IN": {"n": "India", "z": [{"(GMT+05:30) Kolkata": "Asia/Kolkata"}]}, "IO": {"n": "British Indian Ocean Territory", "z": [{"(GMT+06:00) Chagos": "Indian/Chagos"}]}, "IQ": {"n": "Iraq", "z": [{"(GMT+03:00) Baghdad": "Asia/Baghdad"}]}, "IR": {"n": "Iran", "z": [{"(GMT+03:30) Tehran": "Asia/Tehran"}]}, "IS": {"n": "Iceland", "z": [{"(GMT+00:00) Reykjavik": "Atlantic/Reykjavik"}]}, "IT": {"n": "Italy", "z": [{"(GMT+01:00) Rome": "Europe/Rome"}]}, "JE": {"n": "Jersey", "z": [{"(GMT+00:00) Jersey": "Europe/Jersey"}]}, "JM": {"n": "Jamaica", "z": [{"(GMT-05:00) Jamaica": "America/Jamaica"}]}, "JO": {"n": "Jordan", "z": [{"(GMT+02:00) Amman": "Asia/Amman"}]}, "JP": {"n": "Japan", "z": [{"(GMT+09:00) Tokyo": "Asia/Tokyo"}]}, "KE": {"n": "Kenya", "z": [{"(GMT+03:00) Nairobi": "Africa/Nairobi"}]}, "KG": {"n": "Kyrgyzstan", "z": [{"(GMT+06:00) Bishkek": "Asia/Bishkek"}]}, "KH": {"n": "Cambodia", "z": [{"(GMT+07:00) Phnom_Penh": "Asia/Phnom_Penh"}]}, "KI": {"n": "Kiribati", "z": [{"(GMT+13:00) Enderbury": "Pacific/Enderbury"}, {"(GMT+14:00) Kiritimati": "Pacific/Kiritimati"}, {"(GMT+12:00) Tarawa": "Pacific/Tarawa"}]}, "KM": {"n": "Comoros", "z": [{"(GMT+03:00) Comoro": "Indian/Comoro"}]}, "KN": {"n": "Saint Kitts and Nevis", "z": [{"(GMT-04:00) St_Kitts": "America/St_Kitts"}]}, "KP": {"n": "North Korea", "z": [{"(GMT+09:00) Pyongyang": "Asia/Pyongyang"}]}, "KR": {"n": "South Korea", "z": [{"(GMT+09:00) Seoul": "Asia/Seoul"}]}, "KW": {"n": "Kuwait", "z": [{"(GMT+03:00) Kuwait": "Asia/Kuwait"}]}, "KY": {"n": "Cayman Islands", "z": [{"(GMT-05:00) Cayman": "America/Cayman"}]}, "KZ": {"n": "Kazakhstan", "z": [{"(GMT+06:00) Almaty": "Asia/Almaty"}, {"(GMT+05:00) Aqtau": "Asia/Aqtau"}, {"(GMT+05:00) Aqtobe": "Asia/Aqtobe"}, {"(GMT+05:00) Atyrau": "Asia/Atyrau"}, {"(GMT+05:00) Oral": "Asia/Oral"}, {"(GMT+06:00) Qostanay": "Asia/Qostanay"}, {"(GMT+05:00) Qyzylorda": "Asia/Qyzylorda"}]}, "LA": {"n": "Laos", "z": [{"(GMT+07:00) Vientiane": "Asia/Vientiane"}]}, "LB": {"n": "Lebanon", "z": [{"(GMT+02:00) Beirut": "Asia/Beirut"}]}, "LC": {"n": "Saint Lucia", "z": [{"(GMT-04:00) St_Lucia": "America/St_Lucia"}]}, "LI": {"n": "Liechtenstein", "z": [{"(GMT+01:00) Vaduz": "Europe/Vaduz"}]}, "LK": {"n": "Sri Lanka", "z": [{"(GMT+05:30) Colombo": "Asia/Colombo"}]}, "LR": {"n": "Liberia", "z": [{"(GMT+00:00) Monrovia": "Africa/Monrovia"}]}, "LS": {"n": "Lesotho", "z": [{"(GMT+02:00) Maseru": "Africa/Maseru"}]}, "LT": {"n": "Lithuania", "z": [{"(GMT+02:00) Vilnius": "Europe/Vilnius"}]}, "LU": {"n": "Luxembourg", "z": [{"(GMT+01:00) Luxembourg": "Europe/Luxembourg"}]}, "LV": {"n": "Latvia", "z": [{"(GMT+02:00) Riga": "Europe/Riga"}]}, "LY": {"n": "Libya", "z": [{"(GMT+02:00) Tripoli": "Africa/Tripoli"}]}, "MA": {"n": "Morocco", "z": [{"(GMT+01:00) Casablanca": "Africa/Casablanca"}]}, "MC": {"n": "Monaco", "z": [{"(GMT+01:00) Monaco": "Europe/Monaco"}]}, "MD": {"n": "Moldova", "z": [{"(GMT+02:00) Chisinau": "Europe/Chisinau"}]}, "ME": {"n": "Montenegro", "z": [{"(GMT+01:00) Podgorica": "Europe/Podgorica"}]}, "MF": {"n": "Saint Martin", "z": [{"(GMT-04:00) Marigot": "America/Marigot"}]}, "MG": {"n": "Madagascar", "z": [{"(GMT+03:00) Antananarivo": "Indian/Antananarivo"}]}, "MH": {"n": "Marshall Islands", "z": [{"(GMT+12:00) Kwajalein": "Pacific/Kwajalein"}, {"(GMT+12:00) Majuro": "Pacific/Majuro"}]}, "MK": {"n": "Macedonia", "z": [{"(GMT+01:00) Skopje": "Europe/Skopje"}]}, "ML": {"n": "Mali", "z": [{"(GMT+00:00) Bamako": "Africa/Bamako"}]}, "MM": {"n": "Myanmar", "z": [{"(GMT+06:30) Yangon": "Asia/Yangon"}]}, "MN": {"n": "Mongolia", "z": [{"(GMT+08:00) Choibalsan": "Asia/Choibalsan"}, {"(GMT+07:00) Hovd": "Asia/Hovd"}, {"(GMT+08:00) Ulaanbaatar": "Asia/Ulaanbaatar"}]}, "MO": {"n": "Macao", "z": [{"(GMT+08:00) Macau": "Asia/Macau"}]}, "MP": {"n": "Northern Mariana Islands", "z": [{"(GMT+10:00) Saipan": "Pacific/Saipan"}]}, "MQ": {"n": "Martinique", "z": [{"(GMT-04:00) Martinique": "America/Martinique"}]}, "MR": {"n": "Mauritania", "z": [{"(GMT+00:00) Nouakchott": "Africa/Nouakchott"}]}, "MS": {"n": "Montserrat", "z": [{"(GMT-04:00) Montserrat": "America/Montserrat"}]}, "MT": {"n": "Malta", "z": [{"(GMT+01:00) Malta": "Europe/Malta"}]}, "MU": {"n": "Mauritius", "z": [{"(GMT+04:00) Mauritius": "Indian/Mauritius"}]}, "MV": {"n": "Maldives", "z": [{"(GMT+05:00) Maldives": "Indian/Maldives"}]}, "MW": {"n": "Malawi", "z": [{"(GMT+02:00) Blantyre": "Africa/Blantyre"}]}, "MX": {"n": "Mexico", "z": [{"(GMT-06:00) Bahia_Banderas": "America/Bahia_Banderas"}, {"(GMT-05:00) Cancun": "America/Cancun"}, {"(GMT-07:00) Chihuahua": "America/Chihuahua"}, {"(GMT-07:00) Hermosillo": "America/Hermosillo"}, {"(GMT-06:00) Matamoros": "America/Matamoros"}, {"(GMT-07:00) Mazatlan": "America/Mazatlan"}, {"(GMT-06:00) Merida": "America/Merida"}, {"(GMT-06:00) Mexico_City": "America/Mexico_City"}, {"(GMT-06:00) Monterrey": "America/Monterrey"}, {"(GMT-07:00) Ojinaga": "America/Ojinaga"}, {"(GMT-08:00) Tijuana": "America/Tijuana"}]}, "MY": {"n": "Malaysia", "z": [{"(GMT+08:00) Kuala_Lumpur": "Asia/Kuala_Lumpur"}, {"(GMT+08:00) Kuching": "Asia/Kuching"}]}, "MZ": {"n": "Mozambique", "z": [{"(GMT+02:00) Maputo": "Africa/Maputo"}]}, "NA": {"n": "Namibia", "z": [{"(GMT+02:00) Windhoek": "Africa/Windhoek"}]}, "NC": {"n": "New Caledonia", "z": [{"(GMT+11:00) Noumea": "Pacific/Noumea"}]}, "NE": {"n": "Niger", "z": [{"(GMT+01:00) Niamey": "Africa/Niamey"}]}, "NF": {"n": "Norfolk Island", "z": [{"(GMT+12:00) Norfolk": "Pacific/Norfolk"}]}, "NG": {"n": "Nigeria", "z": [{"(GMT+01:00) Lagos": "Africa/Lagos"}]}, "NI": {"n": "Nicaragua", "z": [{"(GMT-06:00) Managua": "America/Managua"}]}, "NL": {"n": "Netherlands", "z": [{"(GMT+01:00) Amsterdam": "Europe/Amsterdam"}]}, "NO": {"n": "Norway", "z": [{"(GMT+01:00) Oslo": "Europe/Oslo"}]}, "NP": {"n": "Nepal", "z": [{"(GMT+05:45) Kathmandu": "Asia/Kathmandu"}]}, "NR": {"n": "Nauru", "z": [{"(GMT+12:00) Nauru": "Pacific/Nauru"}]}, "NU": {"n": "Niue", "z": [{"(GMT-11:00) Niue": "Pacific/Niue"}]}, "NZ": {"n": "New Zealand", "z": [{"(GMT+13:00) Auckland": "Pacific/Auckland"}, {"(GMT+13:45) Chatham": "Pacific/Chatham"}]}, "OM": {"n": "Oman", "z": [{"(GMT+04:00) Muscat": "Asia/Muscat"}]}, "PA": {"n": "Panama", "z": [{"(GMT-05:00) Panama": "America/Panama"}]}, "PE": {"n": "Peru", "z": [{"(GMT-05:00) Lima": "America/Lima"}]}, "PF": {"n": "French Polynesia", "z": [{"(GMT-09:00) Gambier": "Pacific/Gambier"}, {"(GMT-09:30) Marquesas": "Pacific/Marquesas"}, {"(GMT-10:00) Tahiti": "Pacific/Tahiti"}]}, "PG": {"n": "Papua New Guinea", "z": [{"(GMT+11:00) Bougainville": "Pacific/Bougainville"}, {"(GMT+10:00) Port_Moresby": "Pacific/Port_Moresby"}]}, "PH": {"n": "Philippines", "z": [{"(GMT+08:00) Manila": "Asia/Manila"}]}, "PK": {"n": "Pakistan", "z": [{"(GMT+05:00) Karachi": "Asia/Karachi"}]}, "PL": {"n": "Poland", "z": [{"(GMT+01:00) Warsaw": "Europe/Warsaw"}]}, "PM": {"n": "Saint Pierre and Miquelon", "z": [{"(GMT-03:00) Miquelon": "America/Miquelon"}]}, "PN": {"n": "Pitcairn", "z": [{"(GMT-08:00) Pitcairn": "Pacific/Pitcairn"}]}, "PR": {"n": "Puerto Rico", "z": [{"(GMT-04:00) Puerto_Rico": "America/Puerto_Rico"}]}, "PS": {"n": "Palestinian Territory", "z": [{"(GMT+02:00) Gaza": "Asia/Gaza"}, {"(GMT+02:00) Hebron": "Asia/Hebron"}]}, "PT": {"n": "Portugal", "z": [{"(GMT-01:00) Azores": "Atlantic/Azores"}, {"(GMT+00:00) Madeira": "Atlantic/Madeira"}, {"(GMT+00:00) Lisbon": "Europe/Lisbon"}]}, "PW": {"n": "Palau", "z": [{"(GMT+09:00) Palau": "Pacific/Palau"}]}, "PY": {"n": "Paraguay", "z": [{"(GMT-03:00) Asuncion": "America/Asuncion"}]}, "QA": {"n": "Qatar", "z": [{"(GMT+03:00) Qatar": "Asia/Qatar"}]}, "RE": {"n": "Reunion", "z": [{"(GMT+04:00) Reunion": "Indian/Reunion"}]}, "RO": {"n": "Romania", "z": [{"(GMT+02:00) Bucharest": "Europe/Bucharest"}]}, "RS": {"n": "Serbia", "z": [{"(GMT+01:00) Belgrade": "Europe/Belgrade"}]}, "RU": {"n": "Russia", "z": [{"(GMT+12:00) Anadyr": "Asia/Anadyr"}, {"(GMT+07:00) Barnaul": "Asia/Barnaul"}, {"(GMT+09:00) Chita": "Asia/Chita"}, {"(GMT+08:00) Irkutsk": "Asia/Irkutsk"}, {"(GMT+12:00) Kamchatka": "Asia/Kamchatka"}, {"(GMT+09:00) Khandyga": "Asia/Khandyga"}, {"(GMT+07:00) Krasnoyarsk": "Asia/Krasnoyarsk"}, {"(GMT+11:00) Magadan": "Asia/Magadan"}, {"(GMT+07:00) Novokuznetsk": "Asia/Novokuznetsk"}, {"(GMT+07:00) Novosibirsk": "Asia/Novosibirsk"}, {"(GMT+06:00) Omsk": "Asia/Omsk"}, {"(GMT+11:00) Sakhalin": "Asia/Sakhalin"}, {"(GMT+11:00) Srednekolymsk": "Asia/Srednekolymsk"}, {"(GMT+07:00) Tomsk": "Asia/Tomsk"}, {"(GMT+10:00) Ust-Nera": "Asia/Ust-Nera"}, {"(GMT+10:00) Vladivostok": "Asia/Vladivostok"}, {"(GMT+09:00) Yakutsk": "Asia/Yakutsk"}, {"(GMT+05:00) Yekaterinburg": "Asia/Yekaterinburg"}, {"(GMT+04:00) Astrakhan": "Europe/Astrakhan"}, {"(GMT+02:00) Kaliningrad": "Europe/Kaliningrad"}, {"(GMT+03:00) Kirov": "Europe/Kirov"}, {"(GMT+03:00) Moscow": "Europe/Moscow"}, {"(GMT+04:00) Samara": "Europe/Samara"}, {"(GMT+04:00) Saratov": "Europe/Saratov"}, {"(GMT+04:00) Ulyanovsk": "Europe/Ulyanovsk"}, {"(GMT+04:00) Volgograd": "Europe/Volgograd"}]}, "RW": {"n": "Rwanda", "z": [{"(GMT+02:00) Kigali": "Africa/Kigali"}]}, "SA": {"n": "Saudi Arabia", "z": [{"(GMT+03:00) Riyadh": "Asia/Riyadh"}]}, "SB": {"n": "Solomon Islands", "z": [{"(GMT+11:00) Guadalcanal": "Pacific/Guadalcanal"}]}, "SC": {"n": "Seychelles", "z": [{"(GMT+04:00) Mahe": "Indian/Mahe"}]}, "SD": {"n": "Sudan", "z": [{"(GMT+02:00) Khartoum": "Africa/Khartoum"}]}, "SE": {"n": "Sweden", "z": [{"(GMT+01:00) Stockholm": "Europe/Stockholm"}]}, "SG": {"n": "Singapore", "z": [{"(GMT+08:00) Singapore": "Asia/Singapore"}]}, "SH": {"n": "Saint Helena", "z": [{"(GMT+00:00) St_Helena": "Atlantic/St_Helena"}]}, "SI": {"n": "Slovenia", "z": [{"(GMT+01:00) Ljubljana": "Europe/Ljubljana"}]}, "SJ": {"n": "Svalbard and Jan Mayen", "z": [{"(GMT+01:00) Longyearbyen": "Arctic/Longyearbyen"}]}, "SK": {"n": "Slovakia", "z": [{"(GMT+01:00) Bratislava": "Europe/Bratislava"}]}, "SL": {"n": "Sierra Leone", "z": [{"(GMT+00:00) Freetown": "Africa/Freetown"}]}, "SM": {"n": "San Marino", "z": [{"(GMT+01:00) San_Marino": "Europe/San_Marino"}]}, "SN": {"n": "Senegal", "z": [{"(GMT+00:00) Dakar": "Africa/Dakar"}]}, "SO": {"n": "Somalia", "z": [{"(GMT+03:00) Mogadishu": "Africa/Mogadishu"}]}, "SR": {"n": "Suriname", "z": [{"(GMT-03:00) Paramaribo": "America/Paramaribo"}]}, "SS": {"n": "South Sudan", "z": [{"(GMT+03:00) Juba": "Africa/Juba"}]}, "ST": {"n": "Sao Tome and Principe", "z": [{"(GMT+00:00) Sao_Tome": "Africa/Sao_Tome"}]}, "SV": {"n": "El Salvador", "z": [{"(GMT-06:00) El_Salvador": "America/El_Salvador"}]}, "SX": {"n": "Sint Maarten", "z": [{"(GMT-04:00) Lower_Princes": "America/Lower_Princes"}]}, "SY": {"n": "Syria", "z": [{"(GMT+02:00) Damascus": "Asia/Damascus"}]}, "SZ": {"n": "Swaziland", "z": [{"(GMT+02:00) Mbabane": "Africa/Mbabane"}]}, "TC": {"n": "Turks and Caicos Islands", "z": [{"(GMT-05:00) Grand_Turk": "America/Grand_Turk"}]}, "TD": {"n": "Chad", "z": [{"(GMT+01:00) Ndjamena": "Africa/Ndjamena"}]}, "TF": {"n": "French Southern Territories", "z": [{"(GMT+05:00) Kerguelen": "Indian/Kerguelen"}]}, "TG": {"n": "Togo", "z": [{"(GMT+00:00) Lome": "Africa/Lome"}]}, "TH": {"n": "Thailand", "z": [{"(GMT+07:00) Bangkok": "Asia/Bangkok"}]}, "TJ": {"n": "Tajikistan", "z": [{"(GMT+05:00) Dushanbe": "Asia/Dushanbe"}]}, "TK": {"n": "Tokelau", "z": [{"(GMT+13:00) Fakaofo": "Pacific/Fakaofo"}]}, "TL": {"n": "East Timor", "z": [{"(GMT+09:00) Dili": "Asia/Dili"}]}, "TM": {"n": "Turkmenistan", "z": [{"(GMT+05:00) Ashgabat": "Asia/Ashgabat"}]}, "TN": {"n": "Tunisia", "z": [{"(GMT+01:00) Tunis": "Africa/Tunis"}]}, "TO": {"n": "Tonga", "z": [{"(GMT+13:00) Tongatapu": "Pacific/Tongatapu"}]}, "TR": {"n": "Turkey", "z": [{"(GMT+03:00) Istanbul": "Europe/Istanbul"}]}, "TT": {"n": "Trinidad and Tobago", "z": [{"(GMT-04:00) Port_of_Spain": "America/Port_of_Spain"}]}, "TV": {"n": "Tuvalu", "z": [{"(GMT+12:00) Funafuti": "Pacific/Funafuti"}]}, "TW": {"n": "Taiwan", "z": [{"(GMT+08:00) Taipei": "Asia/Taipei"}]}, "TZ": {"n": "Tanzania", "z": [{"(GMT+03:00) Dar_es_Salaam": "Africa/Dar_es_Salaam"}]}, "UA": {"n": "Ukraine", "z": [{"(GMT+02:00) Kiev": "Europe/Kiev"}, {"(GMT+03:00) Simferopol": "Europe/Simferopol"}, {"(GMT+02:00) Uzhgorod": "Europe/Uzhgorod"}, {"(GMT+02:00) Zaporozhye": "Europe/Zaporozhye"}]}, "UG": {"n": "Uganda", "z": [{"(GMT+03:00) Kampala": "Africa/Kampala"}]}, "UM": {"n": "United States Minor Outlying Islands", "z": [{"(GMT-11:00) Midway": "Pacific/Midway"}, {"(GMT+12:00) Wake": "Pacific/Wake"}]}, "US": {"n": "United States", "z": [{"(GMT-10:00) Adak": "America/Adak"}, {"(GMT-09:00) Anchorage": "America/Anchorage"}, {"(GMT-07:00) Boise": "America/Boise"}, {"(GMT-06:00) Chicago": "America/Chicago"}, {"(GMT-07:00) Denver": "America/Denver"}, {"(GMT-05:00) Detroit": "America/Detroit"}, {"(GMT-05:00) Indiana": "America/Indiana/Indianapolis"}, {"(GMT-06:00) Indiana": "America/Indiana/Knox"}, {"(GMT-05:00) Indiana": "America/Indiana/Marengo"}, {"(GMT-05:00) Indiana": "America/Indiana/Petersburg"}, {"(GMT-06:00) Indiana": "America/Indiana/Tell_City"}, {"(GMT-05:00) Indiana": "America/Indiana/Vevay"}, {"(GMT-05:00) Indiana": "America/Indiana/Vincennes"}, {"(GMT-05:00) Indiana": "America/Indiana/Winamac"}, {"(GMT-09:00) Juneau": "America/Juneau"}, {"(GMT-05:00) Kentucky": "America/Kentucky/Louisville"}, {"(GMT-05:00) Kentucky": "America/Kentucky/Monticello"}, {"(GMT-08:00) Los_Angeles": "America/Los_Angeles"}, {"(GMT-06:00) Menominee": "America/Menominee"}, {"(GMT-09:00) Metlakatla": "America/Metlakatla"}, {"(GMT-05:00) New_York": "America/New_York"}, {"(GMT-09:00) Nome": "America/Nome"}, {"(GMT-06:00) North_Dakota": "America/North_Dakota/Beulah"}, {"(GMT-06:00) North_Dakota": "America/North_Dakota/Center"}, {"(GMT-06:00) North_Dakota": "America/North_Dakota/New_Salem"}, {"(GMT-07:00) Phoenix": "America/Phoenix"}, {"(GMT-09:00) Sitka": "America/Sitka"}, {"(GMT-09:00) Yakutat": "America/Yakutat"}, {"(GMT-10:00) Honolulu": "Pacific/Honolulu"}]}, "UY": {"n": "Uruguay", "z": [{"(GMT-03:00) Montevideo": "America/Montevideo"}]}, "UZ": {"n": "Uzbekistan", "z": [{"(GMT+05:00) Samarkand": "Asia/Samarkand"}, {"(GMT+05:00) Tashkent": "Asia/Tashkent"}]}, "VA": {"n": "Vatican", "z": [{"(GMT+01:00) Vatican": "Europe/Vatican"}]}, "VC": {"n": "Saint Vincent and the Grenadines", "z": [{"(GMT-04:00) St_Vincent": "America/St_Vincent"}]}, "VE": {"n": "Venezuela", "z": [{"(GMT-04:00) Caracas": "America/Caracas"}]}, "VG": {"n": "British Virgin Islands", "z": [{"(GMT-04:00) Tortola": "America/Tortola"}]}, "VI": {"n": "U.S. Virgin Islands", "z": [{"(GMT-04:00) St_Thomas": "America/St_Thomas"}]}, "VN": {"n": "Vietnam", "z": [{"(GMT+07:00) Ho_Chi_Minh": "Asia/Ho_Chi_Minh"}]}, "VU": {"n": "Vanuatu", "z": [{"(GMT+11:00) Efate": "Pacific/Efate"}]}, "WF": {"n": "Wallis and Futuna", "z": [{"(GMT+12:00) Wallis": "Pacific/Wallis"}]}, "WS": {"n": "Samoa", "z": [{"(GMT+14:00) Apia": "Pacific/Apia"}]}, "YE": {"n": "Yemen", "z": [{"(GMT+03:00) Aden": "Asia/Aden"}]}, "YT": {"n": "Mayotte", "z": [{"(GMT+03:00) Mayotte": "Indian/Mayotte"}]}, "ZA": {"n": "South Africa", "z": [{"(GMT+02:00) Johannesburg": "Africa/Johannesburg"}]}, "ZM": {"n": "Zambia", "z": [{"(GMT+02:00) Lusaka": "Africa/Lusaka"}]}, "ZW": {"n": "Zimbabwe", "z": [{"(GMT+02:00) Harare": "Africa/Harare"}]}};
var isValidTimezone = ["Europe/Andorra", "Asia/Dubai", "Asia/Kabul", "America/Antigua", "America/Anguilla", "Europe/Tirane", "Asia/Yerevan", "Africa/Luanda", "Antarctica/Casey", "Antarctica/Davis", "Antarctica/DumontDUrville", "Antarctica/Mawson", "Antarctica/McMurdo", "Antarctica/Palmer", "Antarctica/Rothera", "Antarctica/Syowa", "Antarctica/Troll", "Antarctica/Vostok", "America/Argentina/Buenos_Aires", "America/Argentina/Catamarca", "America/Argentina/Cordoba", "America/Argentina/Jujuy", "America/Argentina/La_Rioja", "America/Argentina/Mendoza", "America/Argentina/Rio_Gallegos", "America/Argentina/Salta", "America/Argentina/San_Juan", "America/Argentina/San_Luis", "America/Argentina/Tucuman", "America/Argentina/Ushuaia", "Pacific/Pago_Pago", "Europe/Vienna", "Antarctica/Macquarie", "Australia/Adelaide", "Australia/Brisbane", "Australia/Broken_Hill", "Australia/Currie", "Australia/Darwin", "Australia/Eucla", "Australia/Hobart", "Australia/Lindeman", "Australia/Lord_Howe", "Australia/Melbourne", "Australia/Perth", "Australia/Sydney", "America/Aruba", "Europe/Mariehamn", "Asia/Baku", "Europe/Sarajevo", "America/Barbados", "Asia/Dhaka", "Europe/Brussels", "Africa/Ouagadougou", "Europe/Sofia", "Asia/Bahrain", "Africa/Bujumbura", "Africa/Porto-Novo", "America/St_Barthelemy", "Atlantic/Bermuda", "Asia/Brunei", "America/La_Paz", "America/Kralendijk", "America/Araguaina", "America/Bahia", "America/Belem", "America/Boa_Vista", "America/Campo_Grande", "America/Cuiaba", "America/Eirunepe", "America/Fortaleza", "America/Maceio", "America/Manaus", "America/Noronha", "America/Porto_Velho", "America/Recife", "America/Rio_Branco", "America/Santarem", "America/Sao_Paulo", "America/Nassau", "Asia/Thimphu", "Africa/Gaborone", "Europe/Minsk", "America/Belize", "America/Atikokan", "America/Blanc-Sablon", "America/Cambridge_Bay", "America/Creston", "America/Dawson", "America/Dawson_Creek", "America/Edmonton", "America/Fort_Nelson", "America/Glace_Bay", "America/Goose_Bay", "America/Halifax", "America/Inuvik", "America/Iqaluit", "America/Moncton", "America/Nipigon", "America/Pangnirtung", "America/Rainy_River", "America/Rankin_Inlet", "America/Regina", "America/Resolute", "America/St_Johns", "America/Swift_Current", "America/Thunder_Bay", "America/Toronto", "America/Vancouver", "America/Whitehorse", "America/Winnipeg", "America/Yellowknife", "Indian/Cocos", "Africa/Kinshasa", "Africa/Lubumbashi", "Africa/Bangui", "Africa/Brazzaville", "Europe/Zurich", "Africa/Abidjan", "Pacific/Rarotonga", "America/Punta_Arenas", "America/Santiago", "Pacific/Easter", "Africa/Douala", "Asia/Shanghai", "Asia/Urumqi", "America/Bogota", "America/Costa_Rica", "America/Havana", "Atlantic/Cape_Verde", "America/Curacao", "Indian/Christmas", "Asia/Famagusta", "Asia/Nicosia", "Europe/Prague", "Europe/Berlin", "Europe/Busingen", "Africa/Djibouti", "Europe/Copenhagen", "America/Dominica", "America/Santo_Domingo", "Africa/Algiers", "America/Guayaquil", "Pacific/Galapagos", "Europe/Tallinn", "Africa/Cairo", "Africa/El_Aaiun", "Africa/Asmara", "Africa/Ceuta", "Atlantic/Canary", "Europe/Madrid", "Africa/Addis_Ababa", "Europe/Helsinki", "Pacific/Fiji", "Atlantic/Stanley", "Pacific/Chuuk", "Pacific/Kosrae", "Pacific/Pohnpei", "Atlantic/Faroe", "Europe/Paris", "Africa/Libreville", "Europe/London", "America/Grenada", "Asia/Tbilisi", "America/Cayenne", "Europe/Guernsey", "Africa/Accra", "Europe/Gibraltar", "America/Danmarkshavn", "America/Nuuk", "America/Scoresbysund", "America/Thule", "Africa/Banjul", "Africa/Conakry", "America/Guadeloupe", "Africa/Malabo", "Europe/Athens", "Atlantic/South_Georgia", "America/Guatemala", "Pacific/Guam", "Africa/Bissau", "America/Guyana", "Asia/Hong_Kong", "America/Tegucigalpa", "Europe/Zagreb", "America/Port-au-Prince", "Europe/Budapest", "Asia/Jakarta", "Asia/Jayapura", "Asia/Makassar", "Asia/Pontianak", "Europe/Dublin", "Asia/Jerusalem", "Europe/Isle_of_Man", "Asia/Kolkata", "Indian/Chagos", "Asia/Baghdad", "Asia/Tehran", "Atlantic/Reykjavik", "Europe/Rome", "Europe/Jersey", "America/Jamaica", "Asia/Amman", "Asia/Tokyo", "Africa/Nairobi", "Asia/Bishkek", "Asia/Phnom_Penh", "Pacific/Enderbury", "Pacific/Kiritimati", "Pacific/Tarawa", "Indian/Comoro", "America/St_Kitts", "Asia/Pyongyang", "Asia/Seoul", "Asia/Kuwait", "America/Cayman", "Asia/Almaty", "Asia/Aqtau", "Asia/Aqtobe", "Asia/Atyrau", "Asia/Oral", "Asia/Qostanay", "Asia/Qyzylorda", "Asia/Vientiane", "Asia/Beirut", "America/St_Lucia", "Europe/Vaduz", "Asia/Colombo", "Africa/Monrovia", "Africa/Maseru", "Europe/Vilnius", "Europe/Luxembourg", "Europe/Riga", "Africa/Tripoli", "Africa/Casablanca", "Europe/Monaco", "Europe/Chisinau", "Europe/Podgorica", "America/Marigot", "Indian/Antananarivo", "Pacific/Kwajalein", "Pacific/Majuro", "Europe/Skopje", "Africa/Bamako", "Asia/Yangon", "Asia/Choibalsan", "Asia/Hovd", "Asia/Ulaanbaatar", "Asia/Macau", "Pacific/Saipan", "America/Martinique", "Africa/Nouakchott", "America/Montserrat", "Europe/Malta", "Indian/Mauritius", "Indian/Maldives", "Africa/Blantyre", "America/Bahia_Banderas", "America/Cancun", "America/Chihuahua", "America/Hermosillo", "America/Matamoros", "America/Mazatlan", "America/Merida", "America/Mexico_City", "America/Monterrey", "America/Ojinaga", "America/Tijuana", "Asia/Kuala_Lumpur", "Asia/Kuching", "Africa/Maputo", "Africa/Windhoek", "Pacific/Noumea", "Africa/Niamey", "Pacific/Norfolk", "Africa/Lagos", "America/Managua", "Europe/Amsterdam", "Europe/Oslo", "Asia/Kathmandu", "Pacific/Nauru", "Pacific/Niue", "Pacific/Auckland", "Pacific/Chatham", "Asia/Muscat", "America/Panama", "America/Lima", "Pacific/Gambier", "Pacific/Marquesas", "Pacific/Tahiti", "Pacific/Bougainville", "Pacific/Port_Moresby", "Asia/Manila", "Asia/Karachi", "Europe/Warsaw", "America/Miquelon", "Pacific/Pitcairn", "America/Puerto_Rico", "Asia/Gaza", "Asia/Hebron", "Atlantic/Azores", "Atlantic/Madeira", "Europe/Lisbon", "Pacific/Palau", "America/Asuncion", "Asia/Qatar", "Indian/Reunion", "Europe/Bucharest", "Europe/Belgrade", "Asia/Anadyr", "Asia/Barnaul", "Asia/Chita", "Asia/Irkutsk", "Asia/Kamchatka", "Asia/Khandyga", "Asia/Krasnoyarsk", "Asia/Magadan", "Asia/Novokuznetsk", "Asia/Novosibirsk", "Asia/Omsk", "Asia/Sakhalin", "Asia/Srednekolymsk", "Asia/Tomsk", "Asia/Ust-Nera", "Asia/Vladivostok", "Asia/Yakutsk", "Asia/Yekaterinburg", "Europe/Astrakhan", "Europe/Kaliningrad", "Europe/Kirov", "Europe/Moscow", "Europe/Samara", "Europe/Saratov", "Europe/Ulyanovsk", "Europe/Volgograd", "Africa/Kigali", "Asia/Riyadh", "Pacific/Guadalcanal", "Indian/Mahe", "Africa/Khartoum", "Europe/Stockholm", "Asia/Singapore", "Atlantic/St_Helena", "Europe/Ljubljana", "Arctic/Longyearbyen", "Europe/Bratislava", "Africa/Freetown", "Europe/San_Marino", "Africa/Dakar", "Africa/Mogadishu", "America/Paramaribo", "Africa/Juba", "Africa/Sao_Tome", "America/El_Salvador", "America/Lower_Princes", "Asia/Damascus", "Africa/Mbabane", "America/Grand_Turk", "Africa/Ndjamena", "Indian/Kerguelen", "Africa/Lome", "Asia/Bangkok", "Asia/Dushanbe", "Pacific/Fakaofo", "Asia/Dili", "Asia/Ashgabat", "Africa/Tunis", "Pacific/Tongatapu", "Europe/Istanbul", "America/Port_of_Spain", "Pacific/Funafuti", "Asia/Taipei", "Africa/Dar_es_Salaam", "Europe/Kiev", "Europe/Simferopol", "Europe/Uzhgorod", "Europe/Zaporozhye", "Africa/Kampala", "Pacific/Midway", "Pacific/Wake", "America/Adak", "America/Anchorage", "America/Boise", "America/Chicago", "America/Denver", "America/Detroit", "America/Indiana/Indianapolis", "America/Indiana/Knox", "America/Indiana/Marengo", "America/Indiana/Petersburg", "America/Indiana/Tell_City", "America/Indiana/Vevay", "America/Indiana/Vincennes", "America/Indiana/Winamac", "America/Juneau", "America/Kentucky/Louisville", "America/Kentucky/Monticello", "America/Los_Angeles", "America/Menominee", "America/Metlakatla", "America/New_York", "America/Nome", "America/North_Dakota/Beulah", "America/North_Dakota/Center", "America/North_Dakota/New_Salem", "America/Phoenix", "America/Sitka", "America/Yakutat", "Pacific/Honolulu", "America/Montevideo", "Asia/Samarkand", "Asia/Tashkent", "Europe/Vatican", "America/St_Vincent", "America/Caracas", "America/Tortola", "America/St_Thomas", "Asia/Ho_Chi_Minh", "Pacific/Efate", "Pacific/Wallis", "Pacific/Apia", "Asia/Aden", "Indian/Mayotte", "Africa/Johannesburg", "Africa/Lusaka", "Africa/Harare"];

module.exports = {getTimeZones: getTimeZones, timezoneValidation: isValidTimezone};